

(*
 * curry : ('a * 'b -> 'c) -> ('a -> 'b -> 'c)
 * REQUIRES: true
 * ENSURES: curry f x y =~ f (x, y)
 *)
fun curry (f:'a * 'b -> 'c) : 'a -> 'b -> 'c = 
  fn x => fn y => f (x,y)



(*
 * uncurry : ('a -> 'b -> 'c) -> ('a * 'b -> 'c)
 * REQUIRES: true
 * ENSURES: uncurry f (x, y) =~ f x y
 *)
fun uncurry (f:'a -> 'b -> 'c) : 'a * 'b -> 'c =
  fn (x, y) => f x y