

datatype 'a tree = LEAF | NODE of 'a tree * 'a * 'a tree

(* 
 * mapreduce : (’a -> ’b) -> ’b -> (’b * ’b -> ’b) -> ’a tree -> ’b 
 * REQUIRES: g is commutative and associative, f and g are total
 * ENSURES: mapreduce f b g t yields the g-aggregated elements of the
 *  image of t under f (with base case of b)
 *)
fun mapreduce (f:'a -> 'b) (b:'b) (g:'b * 'b -> 'b) (t:'a tree) : 'b = 
  (case t of 
      LEAF => b
    | NODE (l, x, r) => g (mapreduce f b g l, g (f x, mapreduce f b g r))
  ) 











val x = NODE (NODE (LEAF, 1, LEAF), 2, NODE (LEAF, 3, LEAF))